- Up to now, we have considered non-deterministic processes
- Two main features are missing for modeling a concurrent system:
	- Simultaneous execution of processes
	- Inter-process interaction

- Solutions adopted:
	- Parallel composition, with interleaving semantics
	- Producer/consumer paradigm

Given a set of names N (that denote events)
- $a (\in N)$ denotes consumption of event a
- $\bar{a}$ (for $a \in N$) denotes production of event a
- $a$ and $\bar{a}$ are complementary actions: they let two parallel processes synchronize on the event a

When two processes synchronize, an external observer has no way of understanding what is happening in the system
- synchronization is not observable from the outside; it produces a special ‘silent’ action, that we denote with τ
The set of actions we shall consider is: $N \cup \bar{N} \cup \{\tau\}$

It is also useful to force some processes of the system to synchronize between them (without the possibility of showing to the outside some actions)

The restriction operator P\a restricts the scope of name a to process P (a is visible only from within P)
https://en.wikipedia.org/wiki/Calculus_of_communicating_system

This is similar to local variables in a procedure of an imperative program

The set of CCS processes is defined by the following grammar:
$$P::=\sum_{i \in I} \alpha _{i}.P_{i} \space |\space A(a_{1}\dots a
_{n})\space|\space P|Q \space | \space P\setminus a$$
Dove:
- **$\alpha _{i}.P_{i}$:** the process $P_{i}$ can perform the action $a$ and continue as the process $P_{i}$
- $A(a_{1}\dots a_{n})$ parametric call to a process
![](images/Pasted%20image%2020250414103800.png)

![](images/Pasted%20image%2020250414104010.png)

fino alla 7 compresa...